﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Urbini.Fabio._5BI.BattagliaNavale
{
    /// <summary>
    /// Logica di interazione per MainWindow.xaml
    /// </summary>
    /// 
    public enum GiocatoreCorrente { giocatore1, giocatore2 }
    public partial class MainWindow : Window
    {
        GiocatoreCorrente g = GiocatoreCorrente.giocatore1;
        Giocatore giocatore1;
        Giocatore giocatore2;
        
        public MainWindow(Giocatore player)
        {
            InitializeComponent();
            giocatore1 = player;
            //Flotta flotta = FlottaTools.RandomFlotta();
            giocatore2 = new Giocatore( FlottaTools.RandomFlotta());
        }
        private void AssegnaTag()
        {
            // Assegnazione dei tag ai bottoni 
            Global.AssegnaTag(MappaGiocatore);
            Global.AssegnaTag(MappaAvversario);
        }
        private void AggiornaCaselleGiocatori()
        {
            // Aggiornamento delle caselle in base allo stato della mappa di ogni giocatore
            Global.AggiornaColoreBottoni(MappaGiocatore, giocatore1, true);
            Global.AggiornaColoreBottoni(MappaAvversario, giocatore2, false);
        }
        private void Button_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                Button b = sender as Button;
                if (b != null)
                {
                    int x = Convert.ToInt32(b.Tag.ToString().Split(';')[0]);
                    int y = Convert.ToInt32(b.Tag.ToString().Split(';')[1]);

                    // Se la flotta del giocatore non è ancora affondata, si può cliccare
                    if (!giocatore2.flotta.FlottaAffondata)
                    {
                        // Se statoCellaColpita è diverso da non definito, allora il click è andato a buon fine
                        // Se il click è andato a buon fine, il giocatore passa
                        StatoCella statoCellaColpita = giocatore2.ClickOnXY(new Posizione(x, y));
                        giocatore2.mappa.Aggiorna(giocatore2.flotta);
                        if (!giocatore2.flotta.FlottaAffondata) 
                            g = GiocatoreCorrente.giocatore2;
                    }

                    // Qui per il momento avvengono le azioni dell'IA sulla flotta del primo giocatore
                    if (!giocatore1.flotta.FlottaAffondata)
                    {
                        // Se statoCellaColpita è diverso da non definito, allora il click è andato a buon fine
                        // Se il click è andato a buon fine, il giocatore passa
                        StatoCella statoCellaColpita = giocatore1.ClickOnXY(FlottaTools.RandomPosizione(giocatore1.PosizioniCliccate));
                        giocatore1.mappa.Aggiorna(giocatore1.flotta);
                        g = GiocatoreCorrente.giocatore1;
                    }
                }
            }
            catch (PosizioneGiaCliccata ex)
            {
                // Per il momento non succede nulla
            }
            finally
            {
                AggiornaCaselleGiocatori();
                if (giocatore2.flotta.FlottaAffondata)
                    MessageBox.Show("Hai vinto");
                else if (giocatore1.flotta.FlottaAffondata)
                    MessageBox.Show("Hai perso");
            }
        }
        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            AssegnaTag();
            AggiornaCaselleGiocatori();
        }
    }
}